<?php
require ("../blogconfig/lib-blog.php");
$fnforlog=$_SERVER['SCRIPT_NAME'];

//error_reporting(E_ALL);

CheckID();

require ("$blogconfigpath/lib-functions.php");
require ("$blogconfigpath/lib-outputpagetext.php");

$nowtimestamp=GetNowTimestamp();
$nowtimestamp .= " GMT";

$bloglocationuc=ucwords($bloglocation);

?>
<html><head><title>Publishing All Posts (<?php echo $bloglocationuc; ?>)</title>
<link rel=stylesheet href="a.css" type="text/css"></head>

<body>

<?php
ListNav();

echo "<center><h2>Publishing All Posts ($bloglocationuc)</h2></center><p>";

$wherequerypart="WHERE";
$wherequerypart .= " temphide='n' AND junkpile='n'";

$handle=ConnectToDb();


//We only need to get a limited number of attributes.  The rest are in the cached
//post files we're going to include() later.

$varstoget = array("post_id", "filename", "cachedir", "year", "category", "type", "displaydate");

$sqlvarstoget=implode(", ", $varstoget);

$querytoissue="SELECT $sqlvarstoget FROM postinfo $wherequerypart ORDER BY displaydate DESC";

echo "<div id=\"maintext\">";
echo $querytoissue;
echo "<p>";

$query_result = mysql_query($querytoissue, $handle) or die(mysql_error());

$numofrecords= mysql_numrows($query_result);

if ($numofrecords==0)
{
	echo "<center><big><big>No posts available to publish. Aborting.";
	exit;
}

$x=0;

//We grab all posts, since we're publishing them all.

while ($unpublishedpost_info = mysql_fetch_array($query_result) ) 
{	

	foreach ($varstoget as $varname)
	{
		${$varname}[$x] = $unpublishedpost_info[$varname];
	}


	//For all of the post IDs yielded by the query, we include the
	//cache file for that blog post and create the Blogpost object
	//for it.

	$thiscachefile=$blogcachepath . "/$cachedir[$x]/postid__$post_id[$x]_$filename[$x].php";
	include($thiscachefile);

	//Then we make a variable to use as the name of a variable variable (no typo).

	$Blogpostobj="Blogpost$post_id[$x]";  //Examples: Blogpost5, Blogpost27, etc.

	//We strip slashes out of the post text:
	${$Blogpostobj}->post=stripslashes(${$Blogpostobj}->post);
	${$Blogpostobj}->title=stripslashes(${$Blogpostobj}->title);

	//Then we grab the category and type of the current blog post so
	//we can build up a complete list of what categories and types are present 
	//throughout the entire blog. 
	//
	//This list makes it possible to print the list of category and type links 
	//at the top of each blog page, and also to create folders for 
	//categories and types (if they don't exist already).

	$thiscategory=${$Blogpostobj}->category;
	$thistype=${$Blogpostobj}->type;
	$notforfrontpage=${$Blogpostobj}->notforfrontpage;

	$thisnostandalone=${$Blogpostobj}->nostandalone;

	$allpostids .= "$post_id[$x], ";

	if ($thisnostandalone=="n")
	{	$allstandalones .= "$post_id[$x], ";
	}
	
	$postidsbycategory[$thiscategory] .= "$post_id[$x], ";
	//- $postidsbytype[$thistype] .= "$post_id[$x], ";

	//We also make a pseudo-category containing all posts of any
	//category.  This is used to make the front page, and also
	//the Blog page, which, unlike the front page, doesn't exclude 
	//any posts not meant for the front page.
	//
	//Any_Category is the category used by the Blog section.  Front_Page is the category
	//used by the front page (excludes posts marked as not for the front page).
	//Main_Archive_Cat is the category for the main archive - excludes Site Updates
	//and Journal posts.

	if (!in_array($thiscategory, $cats_excludedfrom_mainarc))
	{
		$postidsbycategory["Main_Archive_Cat"] .= "$post_id[$x], ";
	}
	
	$postidsbycategory["Any_Category"] .= "$post_id[$x], ";

	if ($notforfrontpage=="n")
	{
		$postidsbycategory["Front_Page"] .= "$post_id[$x], ";
	}

	$x++;
}

array_push($category, "Main_Archive_Cat", "Any_Category", "Front_Page");	//The pseudocategories need to be
						//manually added to the category list.

$alluniquecategory=MakeSortedUniqueArray($category);
$alluniquetype=MakeSortedUniqueArray($type);


//Then we make the category and type names which are formatted to be safe
//to use in the pages' source code and for creating any needed folders.

$x=0;
$len=count($alluniquecategory);

while ($x<$len)
{
	$allsafecategory[$x]=MakeSafeFilenameString($alluniquecategory[$x]);
	$x++;
}

$x=0;
$len=count($alluniquetype);

while ($x<$len)
{
	$allsafetype[$x]=MakeSafeFilenameString($alluniquetype[$x]);
	$x++;
}

//These make it possible to get the matching safe type or category for 
//a given display type or category:

$array_alldisplayandsafecategories=array_combine($alluniquecategory,$allsafecategory);
$array_alldisplayandsafetypes=array_combine($alluniquetype, $allsafetype);


$alluniqueyear=array_iunique($year);
$alluniqueyear=array_merge($alluniqueyear);

//Here's where we actually make the folders.
MakeFolders();

//Now we get the links to the main page of every category and type in the blog.
//These go at the top of every blog page.

$local_allcatlinks=GetAllCatLinks("local");
//$localalltypelinks=GetAllTypeLinks();
$local_allcatarclinks=GetAllCatArcLinks("local");

$online_allcatlinks=GetAllCatLinks("online");
$online_allcatarclinks=GetAllCatArcLinks("online");

$local_blognavtext=$local_allcatlinks . "<p>" . $local_allcatarclinks;
$online_blognavtext=$online_allcatlinks . "<p>" . $online_allcatarclinks;

//Uncomment these  to generate SSI files:
require("$blogconfigpath/lib-ssi.php");
OutputACNavFiles($local_blognavtext, $online_blognavtext);


MakeAllCategoryObjects();

function MakeAllCategoryObjects()
{	global $alluniquecategory;
	$curcat=0;
	$numofcats=count($alluniquecategory);

	while ($curcat<$numofcats)
	{	$catname=$alluniquecategory[$curcat];
		MakeCategoryObject($catname);
		$curcat++;
	}
}


function MakeCategoryObject($catname)
{	global $postidsbycategory, $array_alldisplayandsafecategories;

	$idsofcategory=explode(", ", $postidsbycategory[$catname]);
	$idsofcategory=ArrRemoveEmptyValues($idsofcategory);

	$numofidsofcategory=count($idsofcategory);

	$seqid=0;

	while ($seqid<$numofidsofcategory)
	{
		$thispostid=$idsofcategory[$seqid];

		$Blogpostobj="Blogpost$thispostid";

		global ${$Blogpostobj};

		$thistitle=${$Blogpostobj}->title;
		$thisdisplaydate=${$Blogpostobj}->displaydate;
		$thiscategory=${$Blogpostobj}->category;

		$thisyear=${$Blogpostobj}->year;
		$thismonth=${$Blogpostobj}->month;

		$thishidetitle=${$Blogpostobj}->hidetitle;

		if ($thishidetitle=="y")
		{	$thistitle="";
		}

		$titleshere .= "$thistitle, ";
		$dateshere .= "$thisdisplaydate, ";
		$yearshere .= "$thisyear, ";

		$postidsbyear[$thisyear] .= "$thispostid, ";

		$postidsbymonth[$thisyear][$thismonth] .= "$thispostid, ";
		
		$categoriesbyear[$thisyear] .= "$thiscategory, ";
		$categoriesbymonth[$thisyear][$thismonth] .= "$thiscategory, ";

		$postidsequence .= "$thispostid, ";
		$categorieshere .= "$thiscategory, ";
		$typeshere .= "$thistype, ";

		$seqid++;
	}


	$titleshere = explode(", ", $titleshere);
	$dateshere = explode(", ", $dateshere);
	$categorieshere = explode(", ", $categorieshere);
	$typeshere = explode(", ", $typeshere);
	$postidsequence = explode(", ", $postidsequence);
	$yearshere = explode(", ", $yearshere);

	
	$postidsequence = ArrRemoveEmptyValues($postidsequence);

	$safename=$array_alldisplayandsafecategories[$catname];

	$internalsafename=GetInternalSafeName($catname);

	$Catobj="Cat_$internalsafename";
	
	global ${$Catobj};

	${$Catobj}=new Category($catname, $internalsafename, $safename, $titleshere, $dateshere, $categorieshere, $typeshere, $postidsequence, $yearshere, $postidsbyear, $postidsbymonth, $categoriesbyear, $categoriesbymonth);

}

function GetInternalSafeName($displayname)
{
	if ( strpos($displayname, " ") )
	{
		$res=ereg_replace(" ", "_", $displayname);
	}
	else
	{	$res=$displayname;
	}
	return $res;
}


function GetSafeCategories($displaycategories)
{	global $array_alldisplayandsafecategories;

	$x=0;
	$len=count($displaycategories);

	while ($x<$len)
	{	$thiscat=$displaycategories[$x];
		$res[$x]=$array_alldisplayandsafecategories[$thiscat];
		$x++;
	}
	return $res;
}



OutputAllStandalones();
OutputArchivePages();
OutputRecentPostPages();


function OutputArchivePages()
{	global $archivepages_iframeorssi, $archivepages_vertorhorizheader, $blogpath, $postidsbycategory, $alluniquecategory, $array_alldisplayandsafecategories, $mainsitepath, $blogarchivepath, $blogarchivepathweb, $siteupdatearchiveslinklist, $pseudocategories, $lastarchivelink;

	//First, it goes through each category.

	$curcat=0;
	
	$numofcats=count($alluniquecategory);
	$iframeorssi=$archivepages_iframeorssi;
	$usingjavascript=true;

	if ($iframeorssi=="shtml")
	{	$thisfilext="shtml";
		if ($archivepages_vertorhorizheader=="vert")
		{	$navheaderfile="hv";
			$navfooterfile="fv";
			$cssfile="blogv";
		}
		else
		{	$navheaderfile="hh";
			$navfooterfile="fh";
			$cssfile="a";
		}
	}
	
	while ($curcat<$numofcats)
	{	$catname=$alluniquecategory[$curcat];
		$cursafecat=$array_alldisplayandsafecategories[$catname];

		$internalsafename=GetInternalSafeName($catname);
		$Catobj="Cat_$internalsafename";

		global ${$Catobj};
		
		$navdots="../../../";
		$thispath = $blogpath . "/archive/$cursafecat/index.$thisfilext";
		$pagetitle = "Astroblahhh.Com - Blog Archive: $catname";
		$boldheader="<h2>Blog Archive: $catname</h2>";

		if ($catname=="Site Update")
			//Then, we want to output yearly archives.
		{	
			$navdots="../";
			$tocstyle="updatestyle";

			//So, we grab the post IDs by year.
			
			$postidsbyear=${$Catobj}->postidsbyear;
			$categoriesbyear=${$Catobj}->categoriesbyear;
			
			array_reverse($postidsbyear);
			$years=array_keys($postidsbyear);
			$numofyears=count($years);
			
			$arcnavlinks=GenerateArchiveNavLinks($years, "", "Site Update2");
			$siteupdatearchiveslinklist=$arcnavlinks;	

			$i=0;
			$arcindexlinks="";
			$arcyearlinks="<div class=\"blogtoc\"><center>";

			while ($i<$numofyears)
			{
				$curyear=$years[$i];
				$arcyearlinks .= "<a href=\"#$curyear\">$curyear</a> &nbsp;&nbsp;";
				$i++;
			}
			$arcyearlinks = TrimEnd($arcyearlinks, 12);
			
			$arcyearlinks .= "</div></center>";
			
			$arcindexlinks .="<div id=\"maintext\"><div class=\"navlinks\">";
					
			//foreach loop to go through each year and grab the posts.
			foreach ($postidsbyear as $year => $postidsequence)
			{	$arcnavlinks=GenerateArchiveNavLinks($years, $year, "Site Update");
				$blurb = "<center>This page lists many of the major and minor additions and changes to Astroblahhh.Com in $year.</center>";
				$pagetitle = "Astroblahhh.Com - $year Site Update History";
				$boldheader = "<div class=\"navlinks\">$arcnavlinks</div><p><center><h2>$year Site Update History</h2></center>";
				$thispath = $mainsitepath . "/updates/$year.$thisfilext";
				$thesecategories=$categoriesbyear[$year];

				$postidsequence = explode(", ", $postidsequence);
				$postidsequence=ArrRemoveEmptyValues($postidsequence);
				
				$thesecategories = explode(", ", $thesecategories);
				$uniquecategorieshere=MakeSortedUniqueArray($thesecategories);
				$safecategorieshere=GetSafeCategories($uniquecategorieshere);
				
				$numofuniquecategories=count($uniquecategorieshere);
				$numofidshere=count($postidsequence);
				
				$arcindexlinks .= "\n\n<br><br><a name=\"$year\"></a>$arcyearlinks<h2>$year</h2>\n\n<p>";
				
				$arcnavdots="../../../";
				$arcindexlinks .= GetToc("cat", $postidsequence, "multipost", "singlecat", "yeararchivestyle", "chron", $arcnavdots);
				$x=$numofidshere-1;
				$postsfordisplay="";

				while ($x>=0)
				{
					$thispostid=$postidsequence[$x];
					$postsfordisplay .= GetPost($thispostid, $postidsequence, "multipost", "singlecat", $x, "chron", $navdots);
					$x--;
				}
				$pagefooter = "<div class=\"navlinks\">$arcnavlinks<br>";

		//${$ArchivePageobj}=
		
		PublishBlogPage("cat", //$catortype - cat, type or lone.
"archive", 	//$pagetype - standalone, recent or archive.

$pagetitle, 	//$pagetitle - the page's <title>.

$cssfile,		//$cssfile - the CSS stylesheet to use for this page.

$usingjavascript, //$usingjavascript - whether or not to put in the JavaScript and buttons.

$iframeorssi,	//$iframeorssi - for the navigational header/footer stuff.  Whether to
			//use an iframe, an SSI include line, or just import the SSI file and 
			//make a static html file.

$navheaderfile,	//$navheaderfile - what file (without file extension) to use for the nav
			//header stuff.

$navfooterfile,	//$navfooterfile- what file (without file extension) to use for the nav
			//footer stuff.

$navdots,		//$navdots - makes the relative directories for nav file work.
$boldheader,	//$boldheader - the centered large header near the top of the
			//page.

$internalsafename, //$internalsafename - for standalones, this is actually the post_id
			//of the standalone post, but, with pages consisting of multiple
			//posts of a category or type, this is the name of the category or
			//type, converted to an internally-useable, safe form.

"multipost",		//$singleormultipostformat - for standalones, the page only has a
			//single post, hence, single format.  Cat and type pages are in
			//multiple post format.

"singlecat", 		//$singleormulticatformat.  Used for the TOC, if multiple categories
				//are featured on a page, then the category name of each post is 
				//stated in the TOC.

$tocstyle,	//$tocstyle - what style of table of contents to use.

"chron",		//$tocrevchronornot - TOC in chronological order or reverse.

$blurb,		//Whatever text you want below the TOC, if any.

$uniquecategorieshere,	//$uniquecategorieshere - used to make the JavaScript buttons, etc.
				//Only one category is present for lone posts, of course.

$postsfordisplay,	//$postsfordisplay - all the posts on the page, already made.
$postidsequence, 	//$postidsequence - the post ID sequence used.  Used to create TOC.

$thispath,		//$path - The path where this page will be located.
$pagefooter
);
		//	${$ArchivePageobj}->Publish();		
		
			}
			

			$navdots ="../../../";
			$thispath = $blogarchivepath . "/$cursafecat/index.$thisfilext";
			$arcindexlinks .= "</div>";
			$pagetitle="Astroblahhh.Com - $catname Yearly Blog Archives";
			$boldheader = "<h1><center>$catname Yearly Blog Archives</h1></center>";
			$blurb="";
			
			//${$ArchivePageIndexobj}=
			
			//Uncomment for the archive index for Site Updates.
			//PublishSimplePage($pagetitle, $cssfile, $iframeorssi, $navheaderfile, $navfooterfile, $navdots, $boldheader, $blurb, $thispath, $arcindexlinks); 

		}
		else if ($catname=="Main_Archive_Cat")
		{	
			$postidsbymonth=${$Catobj}->postidsbymonth;
			$years=array_keys($postidsbymonth);
			rsort($years);
			
			$lastarchiveyear[Main_Archive_Cat]=$years[0];
			$mostrecentyearmonths=array_keys($postidsbymonth[$years[0]]);
			rsort($mostrecentyearmonths);
			
			$lastarchivemonth[Main_Archive_Cat]=$mostrecentyearmonths[0];
						
			$displaymonth=date("M", mktime(0, 0, 0, $lastarchivemonth[Main_Archive_Cat], 1));
			$displaymonthlc=strtolower($displaymonth);
			$lastarcyear=$lastarchiveyear[Main_Archive_Cat];
			$lessnavdots="";
			$lastarchivelink[$catname]="<a href=\"$lessnavdots" . "blog/archive/$lastarcyear-$displaymonthlc.$thisfilext#blogtoc\">&lt; Earlier Posts</a> | <span class=\"navanchs\"><a href=\"#blogtoc\">TOC</a> - <a href=\"#topofposts\">Top of Posts</a></span>";
			
			
			sort($years);

			$numofyears=count($years);
			$navdots ="../../";
			
			$i=0;
			$arcyearlinks="<div class=\"blogtoc\"><center>";
			while ($i<$numofyears)
			{
				$curyear=$years[$i];
				$arcyearlinks .= "<a href=\"#$curyear\">$curyear</a> &nbsp;&nbsp;";
				$i++;
			}
			$arcyearlinks = TrimEnd($arcyearlinks, 12);
			
			$arcyearlinks .= "</div></center>";		
			
			$arcindexlinks = "<div id=\"maintext\"><div class=\"navlinks\">";

			//Start building up the archive index somewhere around here...
			
			foreach ($postidsbymonth as $year => $monthsinyear)
			{
				$months=array_keys($monthsinyear);
				sort($months);
				$numofmonths=count($months);

				$arcindexlinks .= "\n\n<p><br><a name=\"$year\"></a><p>$arcyearlinks<h2>$year</h2>\n\n<p>";
				
				$monthsinyear=array_reverse($monthsinyear, true);
				
				foreach ($monthsinyear as $month => $postidsequence)
				{
					//OK, the nav links for past and future months...
					$thismonthloc=array_search($month, $months);
					$thisyearloc=array_search($year, $years);

					$displaymonth=date("M", mktime(0, 0, 0, $month, 1));
					$fullmonthname=date("F", mktime(0,0, 0, $month, 1));
					
					//First, we get the links to earlier and later arc pages...
					
					$arcnavlinks=GetEarlierOrLaterArcLinks("both", $thisyearloc, $thismonthloc, $years, $months, $postidsbymonth, $thisfilext, "arcweek", $optionalsuffix);
					
					$arcnavheader="<div class=\"navlinks\">$arcnavlinks<br><a href=\"index.$thisfilext#blogtoc\">Blog Main Archive</a> - <a href=\"../../blog.$thisfilext#blogtoc\">Most Recent Posts</a></div>";


					$blurb = "";
				
					if ($catname=="Main_Archive_Cat")
					{
						$pagetitle = "Astroblahhh.Com - Blog Main Archive - $displaymonth $year";
						$boldheader = "$arcnavheader<p><center><h2>Blog Main Archive - $displaymonth $year</h2></center>";
					}
					$displaymonthlc=strtolower($displaymonth);
					
					$thispath = $blogarchivepath . "/$year-$displaymonthlc.$thisfilext";
						
					$arcindexlinks .= "<br><a href=\"$blogarchivepathweb/$year-$displaymonthlc.$thisfilext#blogtoc\" class=\"archeader\">$fullmonthname</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";

					$categoriesbymonth=${$Catobj}->categoriesbymonth;
				
					$thesecategories=$categoriesbymonth[$year][$month];
				
					$postidsequence = explode(", ", $postidsequence);
					$postidsequence=ArrRemoveEmptyValues($postidsequence);
				
					$thesecategories = explode(", ", $thesecategories);
					$uniquecategorieshere=MakeSortedUniqueArray($thesecategories);
					$safecategorieshere=GetSafeCategories($uniquecategorieshere);
				
					$numofuniquecategories=count($uniquecategorieshere);
	
					$numofidshere=count($postidsequence);
				
					$arcnavdots="../../";
					
					$arcindexlinks .= GetToc("cat", $postidsequence, "multipost", "multicat", "archivestyle", "chron", $arcnavdots);
					
					$arcindexlinks .= "<p>";
									
					$x=$numofidshere-1;
					$postsfordisplay="";
				
					while ($x>=0)
					{
						$thispostid=$postidsequence[$x];

						$postsfordisplay .= GetPost($thispostid, $postidsequence, "multipost", "multicat", $x, "chron", $navdots);
						$x--;
					}

					if ($catname=="Main_Archive_Cat")
					{
						$pagefooter=$arcnavheader;
					}


					//${$ArchivePageobj}=
					
					PublishBlogPage("cat", //$catortype - cat, type or lone.
"archive", 	//$pagetype - standalone, recent or archive.

$pagetitle, 	//$pagetitle - the page's <title>.

$cssfile,		//$cssfile - the CSS stylesheet to use for this page.

$usingjavascript, //$usingjavascript - whether or not to put in the JavaScript and buttons.

$iframeorssi,	//$iframeorssi - for the navigational header/footer stuff.  Whether to
			//use an iframe, an SSI include line, or just import the SSI file and 
			//make a static html file.

$navheaderfile,	//$navheaderfile - what file (without file extension) to use for the nav
			//header stuff.

$navfooterfile,	//$navfooterfile- what file (without file extension) to use for the nav
			//footer stuff.

$navdots,		//$navdots - makes the relative directories for nav file work.
$boldheader,	//$boldheader - the centered large header near the top of the
			//page.

$internalsafename, //$internalsafename - for standalones, this is actually the post_id
			//of the standalone post, but, with pages consisting of multiple
			//posts of a category or type, this is the name of the category or
			//type, converted to an internally-useable, safe form.

"multipost",		//$singleormultipostformat - for standalones, the page only has a
			//single post, hence, single format.  Cat and type pages are in
			//multiple post format.

"multicat", 		//$singleormulticatformat.  Used for the TOC, if multiple categories
				//are featured on a page, then the category name of each post is 
				//stated in the TOC.

$tocstyle,	//$tocstyle - what style of table of contents to use.

"chron",		//$tocrevchronornot - TOC in chronological order or reverse.

$blurb,		//Whatever text you want below the TOC, if any.

$uniquecategorieshere,	//$uniquecategorieshere - used to make the JavaScript buttons, etc.
				//Only one category is present for lone posts, of course.

$postsfordisplay,	//$postsfordisplay - all the posts on the page, already made.
$postidsequence, 	//$postidsequence - the post ID sequence used.  Used to create TOC.

$thispath,		//$path - The path where this page will be located.
$pagefooter
);

			//Last, we handle the page linking to all the archive pages.
			//We built up the links list above.
				}
			}
			
			
			$navdots ="../../";
			$thispath = $blogarchivepath . "/index$optionalsuffix.$thisfilext";
			$arcindexlinks .= "</div></div>";
			
			if ($catname=="Main_Archive_Cat")
			{
				$pagetitle = "Astroblahhh.Com - Main Archive of Blog";
				
				$arcnavheader="<div class=\"navlinks\"><span class=\"navanchs\"><a href=\"#blogtoc\">TOC</a></span><br><a href=\"../../blog.$thisfilext#blogtoc\">Most Recent Posts</a></div><p>";
				
				$boldheader = "$arcnavheader<h1><center>Main Archive of Blog</h1></center>";
				
				global $mainarchiveblurb;
				$blurb = $mainarchiveblurb;
				
				$arcindexlinks .= $arcnavheader;
		
			}
			if ($catname=="Front_Page")
			{
				$pagetitle = "Astroblahhh.Com - Partial Main Archive of Blog";
				$boldheader = "<h1><center>Partial Main Archive of Blog</h1></center>";
				$blurb = "<center>This partial archive excludes the <a href=\"../../updates.shtml\">Site Update</a> stuff and anything else that I considered too boring or otherwise unsuitable for the front page</center>";
			}
				
			//${$ArchivePageIndexobj}=
			
			PublishSimplePage($pagetitle, $cssfile, $iframeorssi, $navheaderfile, $navfooterfile, $navdots, $boldheader, $blurb, $thispath, $arcindexlinks); 

		}
		else if (!in_array($catname, $pseudocategories) )
				//Archives by month.
		{	
			$postidsbymonth=${$Catobj}->postidsbymonth;
			
			$years=array_keys($postidsbymonth);
			
			$lastarchiveyear[$catname]=$years[0];
			$mostrecentyearmonths=array_keys($postidsbymonth[$years[0]]);
			$lastarchivemonth[$catname]=$mostrecentyearmonths[0];

			$navdots ="../../";
			
			$displaymonth=date("M", mktime(0, 0, 0, $lastarchivemonth[$catname], 1));
			$displaymonthlc=strtolower($displaymonth);
			$lastarchivelink[$catname]="<a href=\"$navdots" . "blog/archive/$cursafecat/$lastarchiveyear[$catname]-$displaymonthlc.$thisfilext#blogtoc\">&lt; Earlier Posts</a> | <span class=\"navanchs\"><a href=\"#blogtoc\">TOC</a> - <a href=\"#topofposts\">Top of Posts</a></span>";
			
			
			sort($years);
				
			$numofyears=count($years);
			
			$i=0;
			$arcindexlinks="";
			$arcyearlinks="<div class=\"blogtoc\"><center>";

			while ($i<$numofyears)
			{
				$curyear=$years[$i];
				$arcyearlinks .= "<a href=\"#$curyear\">$curyear</a> &nbsp;&nbsp;";
				$i++;
			}
			$arcyearlinks = TrimEnd($arcyearlinks, 12);
			
			$arcyearlinks .= "</div></center>";
			
			$arcindexlinks .="<div id=\"maintext\"><div class=\"navlinks\">";

			
			//Start building up the archive index somewhere around here...
			
			foreach ($postidsbymonth as $year => $monthsinyear)
			{
				$months=array_keys($monthsinyear);
				sort($months);
				$numofmonths=count($months);

				$arcindexlinks .= "\n\n<br><a name=\"$year\"></a>$arcyearlinks<h2>$year</h2>\n\n<p>";
				
				$monthsinyear=array_reverse($monthsinyear, true);
				
				foreach ($monthsinyear as $month => $postidsequence)
				{
					//OK, the nav links for past and future months...
					$thismonthloc=array_search($month, $months);
					$thisyearloc=array_search($year, $years);

					$displaymonth=date("M", mktime(0, 0, 0, $month, 1));
					$fullmonthname=date("F", mktime(0,0, 0, $month, 1));


					//First, we get the links to earlier and later arc pages...

					$arcnavlinks=GetEarlierOrLaterArcLinks("both", $thisyearloc, $thismonthloc, $years, $months, $postidsbymonth, $thisfilext, "month", "");
					$navdots="../../../";

					$arcnavheader="<div class=\"navlinks\">$arcnavlinks<br><a href=\"../$cursafecat#blogtoc\">$catname Blog Archive</a> | <a href=\"../../$cursafecat#blogtoc\">Most Recent Posts</a></div>";
					
					$blurb = "";
					$pagetitle = "Astroblahhh.Com - $catname Blog Archive - $displaymonth $year";
					$boldheader = "$arcnavheader<p><center><h2>$catname Blog Archive - $displaymonth $year</h2></center>";

					$displaymonthlc=strtolower($displaymonth);

					$thispath = $blogarchivepath . "/$cursafecat/$year-$displaymonthlc.$thisfilext";
					$tocstyle="normal";

					$arcindexlinks .= " <a href=\"$navdots" . "blog/archive/$cursafecat/$year-$displaymonthlc.$thisfilext#blogtoc\" class=\"archeader\">$fullmonthname</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";


					$categoriesbymonth=${$Catobj}->categoriesbymonth;

					$thesecategories=$categoriesbymonth[$year][$month];

					$postidsequence = explode(", ", $postidsequence);
					$postidsequence=ArrRemoveEmptyValues($postidsequence);

					$thesecategories = explode(", ", $thesecategories);
					$uniquecategorieshere=MakeSortedUniqueArray($thesecategories);
					$safecategorieshere=GetSafeCategories($uniquecategorieshere);

					$numofuniquecategories=count($uniquecategorieshere);

					$numofidshere=count($postidsequence);

					$arcindexlinks .= GetToc("cat", $postidsequence, "multipost", "singlecat", "montharchivestyle", "chron", $navdots);

					$arcindexlinks .= "<p>";

					$x=$numofidshere-1;
					$postsfordisplay="";

					while ($x>=0)
					{
						$thispostid=$postidsequence[$x];

						$postsfordisplay .= GetPost($thispostid, $postidsequence, "multipost", "singlecat", $x, "chron", $navdots);
						$x--;
					}

				$pagefooter=$arcnavheader;

					//${$ArchivePageobj}=
					
					PublishBlogPage("cat", //$catortype - cat, type or lone.
"archive", 	//$pagetype - standalone, recent or archive.

$pagetitle, 	//$pagetitle - the page's <title>.

$cssfile,		//$cssfile - the CSS stylesheet to use for this page.

$usingjavascript, //$usingjavascript - whether or not to put in the JavaScript and buttons.

$iframeorssi,	//$iframeorssi - for the navigational header/footer stuff.  Whether to
			//use an iframe, an SSI include line, or just import the SSI file and 
			//make a static html file.

$navheaderfile,	//$navheaderfile - what file (without file extension) to use for the nav
			//header stuff.

$navfooterfile,	//$navfooterfile- what file (without file extension) to use for the nav
			//footer stuff.

$navdots,		//$navdots - makes the relative directories for nav file work.
$boldheader,	//$boldheader - the centered large header near the top of the
			//page.

$internalsafename, //$internalsafename - for standalones, this is actually the post_id
			//of the standalone post, but, with pages consisting of multiple
			//posts of a category or type, this is the name of the category or
			//type, converted to an internally-useable, safe form.

"multipost",		//$singleormultipostformat - for standalones, the page only has a
			//single post, hence, single format.  Cat and type pages are in
			//multiple post format.

"singlecat", 		//$singleormulticatformat.  Used for the TOC, if multiple categories
				//are featured on a page, then the category name of each post is 
				//stated in the TOC.

$tocstyle,	//$tocstyle - what style of table of contents to use.

"chron",		//$tocrevchronornot - TOC in chronological order or reverse.

$blurb,		//Whatever text you want below the TOC, if any.

$uniquecategorieshere,	//$uniquecategorieshere - used to make the JavaScript buttons, etc.
				//Only one category is present for lone posts, of course.

$postsfordisplay,	//$postsfordisplay - all the posts on the page, already made.
$postidsequence, 	//$postidsequence - the post ID sequence used.  Used to create TOC.

$thispath,		//$path - The path where this page will be located.
$pagefooter
);
			
		}
	}
			echo "<p><br>";
			
			$navdots ="../../../";
			$thispath = $blogarchivepath . "/$cursafecat/index.$thisfilext";
			$arcindexlinks .= "</div></div>";
			$pagetitle="Astroblahhh.Com - $catname Blog Monthly Archives";
			
			$arcnavheader="<div class=\"navlinks\"><span class=\"navanchs\"><a href=\"#blogtoc\">TOC</a></span><br><a href=\"../../$cursafecat#blogtoc\">$catname Most Recent Posts</a></div>";

			$boldheader = "$arcnavheader<p><h1><center>$catname Blog Monthly Archives</h1></center>";
			$arcindexlinks .= "<p><br>$arcnavheader";

			//${$ArchivePageIndexobj}=
			
			PublishSimplePage($pagetitle, $cssfile, $iframeorssi, $navheaderfile, $navfooterfile, $navdots, $boldheader, $blurb, $thispath, $arcindexlinks); 
		}
		$curcat++;
	}
}


//The basic procedure is the same for all pages (recent, archive, standalone).
//Get all the components needed to build a page, then, build the page.

function OutputRecentPostPages()
{	global $blogpathweb, $mainsitepathweb, $postidsbycategory, $alluniquecategory, $array_alldisplayandsafecategories, $postsonfrontpage, $postsperrecentpage, $blogpath, $mainsitepath, $recentpostpages_iframeorssi, $recentposts_vertorhorizheader, $siteupdatearchiveslinklist, $lastarchivelink, $pseudocategories, $mainbloglink, $rsspath, $rssfilename, $mainrssfeedname, $mainrssdesc;

	//First, it goes through each category.

	$curcat=0;

	$numofcats=count($alluniquecategory);

	$usingjavascript="true";
	
	$iframeorssi=$recentpostpages_iframeorssi;
	
	if ($iframeorssi=="shtml")
	{	$thisfilext="shtml";

		if ($recentposts_vertorhorizheader=="vert")
		{	$navheaderfile="hv";
			$navfooterfile="fv";
			$cssfile="blogv";
		}
		else
		{	$navheaderfile="hh";
			$navfooterfile="fh";
			$cssfile="a";
		}
	}

	while ($curcat<$numofcats)
	{	$catname=$alluniquecategory[$curcat];
	
		if ($catname=="Main_Archive_Cat")
		{	$curcat++; continue;
		}
		$cursafecat=$array_alldisplayandsafecategories[$catname];

		$navdots="../../";

		$thispath = $blogpath . "/$cursafecat/index.$thisfilext";

		
		$somenavlinks="<div class=\"navlinks\">$lastarchivelink[$catname]<br><a href=\"../archive/$cursafecat#blogtoc\">$catname Blog Archive</a></div>";
		$pagefooter=$somenavlinks;
		
		$pagetitle = "Astroblahhh.Com - $catname Blog - Most Recent Posts";
		$boldheader="$somenavlinks<p><center><h2>$catname Blog - Most Recent Posts</h2></center>";
		$blurb="";
		$tocstyle="normal";

		if ($catname=="Site Update")
		{	$pagetitle = "Astroblahhh.Com - Site Update History";
			$boldheader = "<div class=\"navlinks\">$siteupdatearchiveslinklist</div><p><center><h2>Site Update History</h2></center>";
			$navdots="";
			$tocstyle="updatestyle";
			$blurb="<center>This page lists many of the most recent major and minor additions and changes to Astroblahhh.Com.</center>";
			$thispath = $mainsitepath . "/updates.$thisfilext";
			$pagefooter="<div class=\"navlinks\">$siteupdatearchiveslinklist</div>";

		}
		else if ($catname=="Any_Category")
		{	$pagetitle = "Astroblahhh.Com - Blog Main Page";
			$somelinks=$lastarchivelink[Main_Archive_Cat];
			$somenavlinks="<div class=\"navlinks\">$somelinks<br><a href=\"blog/archive#blogtoc\">Blog Main Archive</a></div>";
			
			$boldheader = "$somenavlinks<p>";
			$navdots ="";
			$thispath = $mainsitepath . "/blog.$thisfilext";
			global $blogsectionblurb;
			$blurb=$blogsectionblurb;
			
			$pagefooter="<p>$somenavlinks";
			
		}
		else if ($catname=="Front_Page")
		{	$pagetitle = "Astroblahhh.Com";
			$somelinks=$lastarchivelink[Main_Archive_Cat];
			$somenavlinks="<div class=\"navlinks\">$somelinks<br><a href=\"blog/archive#blogtoc\">Blog Main Archive</a></div>";
			$pagefooter="<p>$somenavlinks";
			$boldheader = "$somenavlinks<p>";
			$navdots="";
			global $frontpageblurb;
			$blurb=$frontpageblurb;
			
			$thispath = $mainsitepath . "/index.$thisfilext";
		}

		$internalsafename=GetInternalSafeName($catname);
		$Catobj="Cat_$internalsafename";


		global ${$Catobj};

		if ($catname=="Front_Page")
		{	$numofpostsforpage=$postsonfrontpage;
		}
		else
		{	$numofpostsforpage=$postsperrecentpage;
		}


		$idsofcategory=${$Catobj}->postidsequence;

		$idsofcategory=array_slice($idsofcategory, 0, $numofpostsforpage);

		$categorieshere=${$Catobj}->categories;

		$categorieshere=array_slice($categorieshere, 0, $numofpostsforpage);

		$uniquecategorieshere=MakeSortedUniqueArray($categorieshere);
		$safecategorieshere=GetSafeCategories($uniquecategorieshere);


		$numofuniquecategories=count($uniquecategorieshere);


		$numofidsofcategory=count($idsofcategory);

		$yearshere=${$Catobj}->years;
		$yearshere=array_slice($yearshere, 0, $numofpostsforpage);
		$uniqueyearshere=MakeSortedUniqueArray($yearshere);
		$numofyears=count($uniqueyearshere);
		

		$x=0;
		$postsfordisplay="";

		while ($x<$numofpostsforpage && $x<$numofidsofcategory)
		{
			$thispostid=$idsofcategory[$x];

			$singleormultipostformat="multipost";
			
			if ($numofuniquecategories==1 && !in_array($catname, $pseudocategories) )
			{	
				$singleormulticatformat="singlecat";
				//$postsfordisplay .= GetPost($thispostid, $idsofcategory, "multipost", "singlecat", $x, "revchron", $navdots);
			}
			else
			{	
				$singleormulticatformat="multicat";
			}
			$postsfordisplay .= GetPost($thispostid, $idsofcategory, $singleormultipostformat, $singleormulticatformat, $x, "revchron", $navdots);
			
			if ($catname=="Any_Category")
			{	$postsforss .= GetRSSPost($thispostid);
			}
			$x++;

		}
		
if ($catname=="Any_Category")
{	$fullrsspath=$rsspath . "/$rssfilename";
	PublishRSSFeed($mainrssfeedname, $mainbloglink, $mainrssdesc, $postsforss, $fullrsspath);
}
	//${$RecentPageobj}=

PublishBlogPage("cat", //$catortype - cat, type or lone.
"recent", 	//$pagetype - standalone, recent or archive.

$pagetitle, 	//$pagetitle - the page's <title>.

$cssfile,		//$cssfile - the CSS stylesheet to use for this page.

$usingjavascript, //$usingjavascript - whether or not to put in the JavaScript and buttons.

$iframeorssi,	//$iframeorssi - for the navigational header/footer stuff.  Whether to
			//use an iframe, an SSI include line, or just import the SSI file and 
			//make a static html file.

$navheaderfile,	//$navheaderfile - what file (without file extension) to use for the nav
			//header stuff.

$navfooterfile,	//$navfooterfile- what file (without file extension) to use for the nav
			//footer stuff.

$navdots,		//$navdots - makes the relative directories for nav file work.
$boldheader,	//$boldheader - the centered large header near the top of the
			//page.

$internalsafename, //$internalsafename - for standalones, this is actually the post_id
			//of the standalone post, but, with pages consisting of multiple
			//posts of a category or type, this is the name of the category or
			//type, converted to an internally-useable, safe form.

$singleormultipostformat,		//$singleormultipostformat - for standalones, the page only has a
			//single post, hence, single format.  Cat and type pages are in
			//multiple post format.

$singleormulticatformat, 		//$singleormulticatformat.  Used for the TOC, if multiple categories
				//are featured on a page, then the category name of each post is 
				//stated in the TOC.

$tocstyle,	//$tocstyle - what style of table of contents to use.

"revchron",		//$tocrevchronornot - TOC in chronological order or reverse.

$blurb,		//Whatever text you want below the TOC, if any.

$uniquecategorieshere,	//$uniquecategorieshere - used to make the JavaScript buttons, etc.
				//Only one category is present for lone posts, of course.

$postsfordisplay,	//$postsfordisplay - all the posts on the page, already made.
$idsofcategory, 	//$postidsequence - the post ID sequence used.  Used to create TOC.

$thispath,		//$path - The path where this page will be located.
$pagefooter,
$numofyears

);

		$curcat++;

	}

}

function OutputAllStandalones()
{	global $allpostids, $numofrecords, $blogpath, $array_alldisplayandsafecategories, $standalonepages_iframeorssi, $standalonepages_vertorhorizheader, $allstandalones;

	$postidsequence=explode(", ", $allstandalones);
	$postidsequence=ArrRemoveEmptyValues($postidsequence);

	$notusingjavascript=false;

	$numofposts=count($postidsequence);
	
	$iframeorssi=$standalonepages_iframeorssi;
	
	if ($iframeorssi=="iframe")
	{	$thisfilext="html";

		if ($standalonepages_vertorhorizheader=="vert")
		{	$navheaderfile="ihv";
			$navfooterfile="ifv";
			$cssfile="blogv";
		}
		else
		{	$navheaderfile="ihh";
			$navfooterfile="ifh";
			$cssfile="a";
		}
	}
	else if ($iframeorssi=="shtml")
	{	$thisfilext="shtml";

		if ($standalonepages_vertorhorizheader=="vert")
		{	$navheaderfile="hv";
			$navfooterfile="fv";
			$cssfile="blogv";
		}
		else
		{	$navheaderfile="hh";
			$navfooterfile="fh";
			$cssfile="a";
		}
	}

	$x=0;
	while ($x<$numofposts)
	{	$thispostid=$postidsequence[$x];
		$backforwardlinks="";
		
		$Blogpostobj="Blogpost$thispostid";
		global ${$Blogpostobj};
		
		$thishidetitle=${$Blogpostobj}->hidetitle;
		$thisdisplaydate=${$Blogpostobj}->displaydate;
		$thistimestamp = strtotime($thisdisplaydate);
		$thistitledate = date("n/j/Y", $thistimestamp);
		
		if ($thishidetitle=="y")
		{	$thistitle=$thistitledate;
			$thistitledate="";
		}
		else
		{	$thistitle=${$Blogpostobj}->title;
		}
		
		if ($x>0)
		{	$nextpostid=$postidsequence[$x-1];
			$NextBlogpostobj="Blogpost$nextpostid";
			global ${$NextBlogpostobj};
			$nextcat=${$NextBlogpostobj}->category;
			//$nextype=${$NextBlogpostobj}->type;
			$nextsafecat=$array_alldisplayandsafecategories[$nextcat];

			$nextdisplaydate=${$NextBlogpostobj}->displaydate;
			
			$timestamp = strtotime($nextdisplaydate);
			$titledate = date("n/j/Y", $timestamp);
			
			$nextitle=${$NextBlogpostobj}->title;
			$nextfilename=${$NextBlogpostobj}->filename;
			
			$backforwardlinks = "<a href=\"../$nextsafecat/$nextfilename-$nextpostid.$thisfilext#blogtoc\">$nextitle $titledate ></a>";

		}
		$prevpostid=$postidsequence[$x+1];

		$backforwardlinks = " |<br><span class=\"navanchs\"><a href=\"#post$thispostid\">$thistitle $thistitledate</a></span><br><span class=\"navlinks\">| " . $backforwardlinks . "</span>";
	
		if ($prevpostid)
		{	
			$PrevBlogpostobj="Blogpost$prevpostid";
			global ${$PrevBlogpostobj};
			
			$prevdisplaydate=${$PrevBlogpostobj}->displaydate;
			
			$timestamp = strtotime($prevdisplaydate);
			$titledate = date("n/j/Y", $timestamp);
			
			$prevcat=${$PrevBlogpostobj}->category;

			$prevsafecat=$array_alldisplayandsafecategories[$prevcat];
			$prevtitle=${$PrevBlogpostobj}->title;
			$prevfilename=${$PrevBlogpostobj}->filename;
			$linksofar=$backforwardlinks;
			$backforwardlinks="<a href=\"../$prevsafecat/$prevfilename-$prevpostid.$thisfilext#blogtoc\">&lt; $titledate $prevtitle</a>" . $linksofar;
		}
		
		$thisfilename=${$Blogpostobj}->filename;
		$thisyear=${$Blogpostobj}->year;
		$thiscategory=${$Blogpostobj}->category;
		$thisafecat=$array_alldisplayandsafecategories[$thiscategory];

			$thispath = $blogpath . "/$thisafecat/$thisfilename-$thispostid.$thisfilext";

			$thispagetitle="Astroblahhh.Com - $thiscategory Blog Post - $thistitle - $thistitledate";
			
			$usingjavascript="true";

			$navdots="../../";
			
			if ($thiscategory=="Site Update")
			{
				$somenavlinks="<div class=\"navlinks\">$backforwardlinks<br><a href=\"../../updates/$thisyear.shtml#blogtoc\">$thiscategory Blog Archive</a> | <a href=\"../../updates.shtml#blogtoc\">Most Recent Posts</a></div><p>";
			}
			else
			{
				$somenavlinks="<div class=\"navlinks\">$backforwardlinks<br><a href=\"../archive/$thisafecat#blogtoc\">$thiscategory Blog Archive</a> | <a href=\"../$thisafecat#blogtoc\">Most Recent Posts</a></div><p>";
			}
			
			$pagefooter=$somenavlinks;
			
			$boldheader="$somenavlinks<center><h3>$thiscategory Blog Post:</h3><h2>$thistitle<br>$thistitledate</h2></center>";


			$uniquecategorieshere = array($thiscategory);
			
			$postsfordisplay = GetPost($thispostid, $postidsequence, "singlepost", "multicat", "", "chron", $navdots);
			

//${$StandalonePageobj}=

PublishBlogPage("lone", //$catortype - cat, type or lone.
"standalone", 	//$pagetype - standalone, recent or archive.

$thispagetitle, 	//$pagetitle - the page's <title>.

$cssfile,		//$cssfile - the CSS stylesheet to use for this page.

$usingjavascript, //$usingjavascript - whether or not to put in the JavaScript and buttons.

$iframeorssi,	//$iframeorssi - for the navigational header/footer stuff.  Whether to
			//use an iframe, an SSI include line, or just import the SSI file and 
			//make a static html file.

$navheaderfile,	//$navheaderfile - what file (without file extension) to use for the nav
			//header stuff.

$navfooterfile,	//$navfooterfile- what file (without file extension) to use for the nav
			//footer stuff.

$navdots,		//$navdots - makes the relative directories for nav file work.
$boldheader,	//$boldheader - the centered large header near the top of the
			//page.

$internalsafename, //$internalsafename - for standalones, this is actually the post_id
			//of the standalone post, but, with pages consisting of multiple
			//posts of a category or type, this is the name of the category or
			//type, converted to an internally-useable, safe form.

"singlepost",		//$singleormultipostformat - for standalones, the page only has a
			//single post, hence, single format.  Cat and type pages are in
			//multiple post format.

"multicat", 	//$singleormulticatformat.  Used for the TOC, if multiple categories
				//are featured on a page, then the category name of each post is 
				//stated in the TOC.
				
"normalstyle",	//$tocstyle - what style of table of contents to use.

"chron",		//$tocrevchronornot - TOC in chronological order or reverse.
			//Doesn't really matter which for a lone post.

$blurb,		//Whatever text you want below the TOC, if any.

$uniquecategorieshere,	//$uniquecategorieshere - used to make the JavaScript buttons, etc.
				//Only one category is present for lone posts, of course.

$postsfordisplay,	//$postsfordisplay - all the posts on the page, already made.
$thispostid, 	//$postidsequence - the post ID sequence used.  

	//$filename - The file name for this page.
$thispath,		//$path - The path where this page will be located.
$pagefooter
);
			$x++;

	}
}

?>


<html><head><title>Publish New Posts Results</title>
<link rel=stylesheet href="css/a.css" type="text/css"></head>

<body><center>

<?php 

	echo "Total # of posts: $numofrecords<br>Number published: $numofrecords<p><br>";

	echo "<b>Categories published:</b> ";
	print_r($alluniquecategory);
	echo "<p>
	<b>Types published:</b> ";
	print_r($alluniquetype);


	echo "<div id=\"maintext\"><table>";
	echo $displaytext; 
	echo "</table><p>";
	
	MakeIncludeFile("var-lastpub.php", "lastpublishdate", $nowtimestamp, "usequotes", "w");
	
	ListNav();
?>